#include "ScanLibraryImpl.h"
#include "CalibrationControllerImpl.h"
#include "scripts/ThresholdScan.h"
#include "scripts/StrobeDelayScan.h"
#include "scripts/NMaskScan.h"
#include "scripts/TokenScan.h"

namespace SctCalibrationController {
using namespace Scripts;    
    
ScanLibraryImpl::ScanLibraryImpl() {
    api = 0;
}
    
ScanLibraryImpl& ScanLibraryImpl::instance() {
    static ScanLibraryImpl* instance = new ScanLibraryImpl();
    return *instance;
}

Sct_SctApi_T_Scan& ScanLibraryImpl::thresholdScan(unsigned long nTrigs) const {
    Sct_SctApi_T_SctApi& api = *CalibrationControllerImpl::instance().getApi();
    return ThresholdScan::thresholdScan(api, nTrigs);
}

Sct_SctApi_T_Scan& ScanLibraryImpl::thresholdScanfC(unsigned long nTrigs, double calCharge) const {
    Sct_SctApi_T_SctApi& api = *CalibrationControllerImpl::instance().getApi();
    return ThresholdScan::thresholdScan(api, nTrigs, calCharge);    
}

Sct_SctApi_T_Scan& ScanLibraryImpl::strobeDelayScan(unsigned long nTrigs) const {
    Sct_SctApi_T_SctApi& api = *CalibrationControllerImpl::instance().getApi();
    return StrobeDelayScan::strobeDelayScan(api, nTrigs);        
}

Sct_SctApi_T_Scan& ScanLibraryImpl::nmaskScan(unsigned long nTrigs) const {
    Sct_SctApi_T_SctApi& api = *CalibrationControllerImpl::instance().getApi();
    return NMaskScan::nmaskScan(api, nTrigs);    
}

Sct_SctApi_T_Scan& ScanLibraryImpl::tokenScan() const {
    Sct_SctApi_T_SctApi& api = *CalibrationControllerImpl::instance().getApi();
    return TokenScan::tokenScan(api);    
}

}
