#include "ScanLibrary.h"
#include "CalibrationController.h"

namespace SctCalibrationController {
namespace Ipc {
    
ScanLibrary::ScanLibrary() : IPCCallback(&CalibrationController::getServer()) {
}

Sct_SctApi_T_Scan * ScanLibrary::thresholdScan (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs) {
    return &thresholdScan(nTrigs);
}

Sct_SctApi_T_Scan * ScanLibrary::thresholdScanfC (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs, ilu_Real calCharge) {
    return &thresholdScanfC(nTrigs, calCharge);
}

Sct_SctApi_T_Scan * ScanLibrary::strobeDelayScan (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs) {
    return &strobeDelayScan(nTrigs);
}
    
Sct_SctApi_T_Scan * ScanLibrary::nmaskScan (Sct_CalibrationControllerStatus *_status, ilu_Cardinal nTrigs) {
    return &nmaskScan(nTrigs);
}
   
Sct_SctApi_T_Scan * ScanLibrary::tokenScan (Sct_CalibrationControllerStatus *_status) {
    return &tokenScan();
}

}
}
