#ifndef NMASKSCAN_H
#define NMASKSCAN_H

#include "../ipc/Sct_CalibrationController.hh"

#include "../SctApiException.h"
#include "Sct/LogicErrors.h"

#include <CommonWithDsp/ABCD/ABCDscans.h>

using namespace Sct;
namespace SctCalibrationController {
namespace Scripts {
    
class NMaskScan {
public:
    static Sct_SctApi_T_Scan& nmaskScan(Sct_SctApi_T_SctApi& api, unsigned long nTrigs) {	
	Sct_SctApiStatus status;
	Sct_SctApi_T_Scan* s = api.defaultScan(&status);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "NMaskScan", __FILE__, __LINE__);
	
	Sct_SctApi_T_Trigger* t = s->getTrigger1(&status);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "NMaskScan", __FILE__, __LINE__);
	
	t->singleL1A(&status);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "NMaskScan", __FILE__, __LINE__);
	
	s->setNTrigs(&status, nTrigs);		
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "NMaskScan", __FILE__, __LINE__);
	
	s->configure(&status, ST_NMASK, 0, 128, 1);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "NMaskScan", __FILE__, __LINE__);
	
	return *s;
    }
    
private:
    NMaskScan();
};
    
}
}

#endif //NMASKSCAN_H
