#ifndef TOKENSCAN_H
#define TOKENSCAN_H

#include "../ipc/Sct_CalibrationController.hh"

#include "../SctApiException.h"
#include "Sct/LogicErrors.h"

#include <CommonWithDsp/ABCD/ABCDscans.h>

using namespace Sct;

namespace SctCalibrationController {
namespace Scripts {
    
class TokenScan {
public:
    static Sct_SctApi_T_Scan& tokenScan(Sct_SctApi_T_SctApi& api) {	
	Sct_SctApiStatus status;
        Sct_SctApi_T_Scan* s = api.defaultScan(&status);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "tokenScan", __FILE__, __LINE__);
	
        s->setNTrigs(&status, 100);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "tokenScan", __FILE__, __LINE__);
	
        Sct_SctApi_T_Trigger* t = s->getTrigger1(&status);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "tokenScan", __FILE__, __LINE__);
	
        t->singleL1A(&status);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "tokenScan", __FILE__, __LINE__);
	
        s->configure(&status, ST_TOKEN, 0, 36, 1);
	if (status.returnCode != 0)
	    throw SctApiException(status.returnCode, "tokenScan", __FILE__, __LINE__);	
	
	return *s;
    }
    
private:
    TokenScan();
};
    
}
}

#endif //TOKENSCAN_H
