/*
 * ScriptFactory.java
 *
 * Created on 28 November 2002, 14:57
 */

package GuiComponents.scripting;
import GuiComponents.Console.*;
import org.apache.bsf.*;

/**
 *
 * @author  palmer
 * A list of static methods that ScriptFactories should implement to enable easy addition to the GUI
 */
public class JavaScriptFactory implements ScriptFactory {
    public BSFEngine createEngine(BSFManager manager) {
        try {
            return manager.loadScriptingEngine("javascript");
        } catch (BSFException be) {
            System.err.println("Error loading javascript scripting engine: " + be);
            return null;
        }
    }
    
    public JConsole createConsole() {
        return new JConsole();        
    }
    
    public DefaultInterpreter createInterpreter(BSFEngine engine, JConsole console, NameCompleter nc) {
        return new JavaScriptInterpreter(console, engine, nc);
    }
    
    public NameCompleter createNameCompleter(BSFEngine engine, SearchableObjectRegistry registry) {
        return registry;
    }
    
}
