/*
 * JavaScriptInterpreter.java
 *
 * Created on 28 November 2002, 15:53
 */

package GuiComponents.scripting;
import GuiComponents.Console.*;
import org.apache.bsf.*;
import org.mozilla.javascript.*;

/**
 *
 * @author  palmer
 */
public class JavaScriptInterpreter extends DefaultInterpreter {
    
    /** Creates a new instance of JavaScriptInterpreter */
    public JavaScriptInterpreter(JConsole console, BSFEngine engine, NameCompleter nc) {
        super(console, engine, nc);
    }
    
    /** Should be overridden to return false when executing a line that returns void.
     *
     */
    protected boolean printObject(Object val) {
        if (val == null) return false;
        if (val instanceof Undefined) return false;
        return true;
    }
    
    public String toString() {
        return "JavaScriptInterpreter";
    }
    
}
