#ifndef SCTDATA_IO_FITSCANRESULTSTREAMER_H
#define SCTDATA_IO_FITSCANRESULTSTREAMER_H

#include "ScanResultStreamer.h"
#include "../FitScanResultIOHelper.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"

namespace SctData {
namespace IO {

/**
This class is an Streamer for reading/writing FitScanResults.
*/
class FitScanResultStreamer : public ScanResultStreamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);

private:
    FitScanResultIOHelper helper;			///< The IOHelper
    FitScanResultStreamer() throw() ;		///< Private constructor
    static bool inMap;				///< The static dummy variable for the IOManager map

};
}
}
#endif //#ifndef SCTDATA_IO_FITSCANRESULTSTREAMER_H
