#ifndef SCTDATA_IO_ModuleConfigurationStreamer_H
#define SCTDATA_IO_ModuleConfigurationStreamer_H

#include <CommonWithDsp/sctStructure.h>
#include "Sct/Streamable.h"
#include "Sct/Streamer.h"
#include "Sct/Exception.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"

using namespace Sct;

namespace SctData {
namespace IO {

/**
This class is an Streamer for reading/writing ModuleConfigurations to/from IS.
*/
class ModuleConfigurationStreamer : public virtual Streamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);

private:
    void readChipConfig(IStream& in, ABCDChip& data) const throw(Sct::LogicError, Sct::IoError);
    void writeChipConfig(OStream& out, const ABCDChip& data) const throw(Sct::LogicError, Sct::IoError);

    ModuleConfigurationStreamer() throw();		///< The private constructor
    static bool inMap;				///< The static dummy variable for the IOManager map
};
}
}
#endif //#ifndef SCTDATA_IO_ModuleConfigurationStreamer_H
