#include "NMaskTestResultStreamer.h"
#include "../NMaskTestResult.h"

using namespace Sct;

namespace SctData {
namespace IO {

NMaskTestResultStreamer::NMaskTestResultStreamer() throw() {}

bool NMaskTestResultStreamer::inMap = IOManager::addToMap("SctData::NMaskTestResult", auto_ptr<Streamer>(new NMaskTestResultStreamer()));

shared_ptr<Streamable> NMaskTestResultStreamer::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError){
    shared_ptr<Streamable> ad (new NMaskTestResult());
    read(in, *ad, manager);
    return ad;
}

void NMaskTestResultStreamer::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    //Let superclass do its work
    TestResultStreamer::write(out, ob, manager);
}

void NMaskTestResultStreamer::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    TestResultStreamer::read(in, ob, manager);
}

} 
}
