#ifndef SCTDATA_IO_PIPELINETESTRESULTSTREAMER_H
#define SCTDATA_IO_PIPELINETESTRESULTSTREAMER_H

#include "TestResultStreamer.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of PipelineTestResult objects
 */
class PipelineTestResultStreamer : public TestResultStreamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    
private:
    PipelineTestResultStreamer() throw();
    static bool inMap;
};
}
}

#endif // #ifndef SCTDATA_IO_PIPELINETESTRESULTSTREAMER_H
