#include "ResponseCurveStreamer.h"
#include "../ResponseCurve.h"

using namespace Sct;

namespace SctData {
namespace IO {

ResponseCurveStreamer::ResponseCurveStreamer() throw() {}

bool ResponseCurveStreamer::inMap = IOManager::addToMap("SctData::ResponseCurve", auto_ptr<Streamer>(new ResponseCurveStreamer()));

void ResponseCurveStreamer::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    const ResponseCurve& rc = dynamic_cast<const ResponseCurve&>(ob);
    out << ResponseCurveMap::getMap().getIndex(rc.getCurveName());
    for (int ipar=0; ipar<3; ++ipar) {
        out << rc.getFunction()->GetParameter(ipar);
    }
}

shared_ptr<Streamable> ResponseCurveStreamer::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError) {
    int index;
    in >> index;
    auto_ptr<ResponseCurve> rc=ResponseCurveMap::getMap().get(index);
    for (int ipar=0; ipar<3; ++ipar) {
        double value;
        in >> value;
        rc->getFunction()->SetParameter(ipar,value);
    }
    return shared_ptr<Streamable>(rc);
}

void ResponseCurveStreamer::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    dynamic_cast<ResponseCurve&>(ob);
    ob = *read(in, manager);
}
}
}

