#include "../StrobeDelayTestResult.h"
#include "StrobeDelayTestResultStreamer.h"
#include <vector>

using namespace Sct;

namespace SctData {
namespace IO {

StrobeDelayTestResultStreamer::StrobeDelayTestResultStreamer() throw() {
}

bool StrobeDelayTestResultStreamer::inMap = IOManager::addToMap("SctData::StrobeDelayTestResult", auto_ptr<Streamer>(new StrobeDelayTestResultStreamer()));

shared_ptr<Streamable> StrobeDelayTestResultStreamer::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError) {
    shared_ptr<Streamable> ad (new StrobeDelayTestResult());
    read(in, *ad, manager);
    return ad;
}

void StrobeDelayTestResultStreamer::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    //Let superclass do its work
    TestResultStreamer::write(out, ob, manager);

    const StrobeDelayTestResult& mytest = dynamic_cast<const StrobeDelayTestResult&>(ob);

    out << mytest.getFraction();

    unsigned int nopt=mytest.getNOptima();
    out << nopt;
    for (unsigned int i=0; i<nopt; ++i) {
        out << mytest.getOptimum(i);
    }
}

void StrobeDelayTestResultStreamer::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    TestResultStreamer::read(in, ob, manager);

    StrobeDelayTestResult& mytest = dynamic_cast<StrobeDelayTestResult&>(ob);
    double fraction;
    in >> fraction;
    mytest.setFraction(fraction);
    unsigned int nopt;
    in >> nopt;
    mytest.setNOptima(nopt);
    for (unsigned int ichip=0; ichip<nopt; ++ichip) {
        double opt;
        in >> opt ;
        mytest.setOptimum(ichip, opt);
    }
}

}
}
