#ifndef SCTDATA_IO_TESTRESULTSTREAMER_H
#define SCTDATA_IO_TESTRESULTSTREAMER_H

#include "Sct/Streamer.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"

using namespace Sct;

namespace SctData {
namespace IO {

/**
 * Implimentation of the IS publish and refresh methods for the abstract class TestResult.
 * The published and refreshed elements are:
 * -> run number -> module name -> the `special' point. 
 * -> a list of the scan numbers and the scan `test point' values.
 * -> the defect list.
 * <P> Doesn't implement createObject.
 */

class TestResultStreamer : public virtual Streamer {
protected:
    TestResultStreamer() throw();
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
};


}
}
#endif // #ifndef SCTDATA_IO_TESTRESULTSTREAMER_H
