#ifndef SCTDATA_IO_TIMEWALKTESTRESULTSTREAMER_H
#define SCTDATA_IO_TIMEWALKTESTRESULTSTREAMER_H

#include "TestResultStreamer.h"
#include "../TimeWalkTestResult.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of TimeWalkTestResult objects
 */
class TimeWalkTestResultStreamer : public TestResultStreamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    void writeChipResult(OStream& out, const TimeWalkTestResult::ChipTWResult&, const IOManager& manager) const throw(LogicError, IoError) ;
    void readChipResult(IStream& in, TimeWalkTestResult::ChipTWResult&, const IOManager& manager) const throw(LogicError, IoError) ;
private:
    TimeWalkTestResultStreamer() throw();
    static bool inMap;
};
}
}

#endif // #ifndef SCTDATA_IO_TIMEWALKTESTRESULTSTREAMER_H
