#ifndef SCTDATA_IO_TRIMRANGETESTRESULTSTREAMER_H
#define SCTDATA_IO_TRIMRANGETESTRESULTSTREAMER_H

#include "TestResultStreamer.h"

namespace SctData {
class TrimRangeTestResult;
class TrimRangeTestResultData;
}

using namespace SctData;

namespace SctData {
namespace IO {


/**
 * This class allows publishing and refreshing of TrimRangeTestResult objects to and from IS.
 * The published and refreshed elements are:
 * 
 */
class TrimRangeTestResultStreamer : public TestResultStreamer {
public:
    //Streamer overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);

private:
    void writeData(OStream& out, const TrimRangeTestResult::ChipTrimData& ob, const IOManager& manager) const throw(Sct::LogicError, Sct::IoError);
    void readData(IStream& in, TrimRangeTestResult& mytest, TrimRangeTestResult::ChipTrimData& ob, const IOManager& manager) const throw(Sct::LogicError, Sct::IoError);

    void writeTrim(OStream& out, const TrimRangeTestResult::ChipTrim& ob, const IOManager& manager) const throw(Sct::LogicError, Sct::IoError);
    void readTrim(IStream& in, TrimRangeTestResult& mytest, TrimRangeTestResult::ChipTrim& ob, const IOManager& manager) const throw(Sct::LogicError, Sct::IoError);

    TrimRangeTestResultStreamer() throw();	///< Constructor is private
    static bool inMap;				///< The static dummy variable for the IOManager map
};
}
}
#endif // #ifndef SCTDATA_IO_TRIMRANGETESTRESULTSTREAMER_H
