#include "ScanHeader.h"
#include "ConfigurationVariable.h"
#include <iostream>
#include <sstream>

using namespace Sct;
using namespace std;

namespace SctData {

ScanHeader::ScanHeader(unsigned int scanNumber, unsigned int runNumber, string moduleName, const ConfigurationVariable& variable) throw() :
                       scanNumber(scanNumber), runNumber(runNumber), moduleName(moduleName), variable(&variable) {}

ScanHeader::ScanHeader() throw() : scanNumber(0), runNumber(0), moduleName(""), variable() {}

ScanHeader::~ScanHeader() throw() {}

bool ScanHeader::operator==(const ScanHeader& scan) const throw() {
    if (scanNumber == scan.scanNumber && runNumber == scan.runNumber &&
            moduleName == scan.moduleName && *variable == *scan.variable)
        return true;
    else
        return false;
}

//Streamable and Serializable overrides
string ScanHeader::getClassName() const throw() {
    return "SctData::ScanHeader";
}

string ScanHeader::getUniqueID() const throw() {
    return getUniqueID(runNumber, scanNumber, moduleName);
}

string ScanHeader::getUniqueID(unsigned int runNumber, unsigned int scanNumber, const string& moduleName) throw() {
    ostringstream oss;
    oss << runNumber << "." << scanNumber << "." << moduleName;
    return oss.str();
}

}
