#include <iostream>
// #include <fstream>
#include <stdexcept>

#include <unistd.h>
#include <stdio.h> // For tempnam

#include "log.h"

Log::Log() : std::ofstream("SctApiLog.log", std::ios::app) {
  std::cout << "Log started\n";
  *this << "Started SctAPi as pid = " << ((int)getpid()) << std::endl;
}

Log::Log(std::string fname) : std::ofstream(fname.c_str(), std::ios::app) {
  std::cout << "Log started\n";
  *this << "Started log to " << fname << " as pid = " << ((int)getpid()) << std::endl;
}

Log::Log(std::string pref, int instance) : std::ofstream(tempnam(NULL, pref.c_str()), std::ios::app) {
  std::cout << "Log started\n";
  *this << "Started log to " << pref << " as pid = " << ((int)getpid()) << std::endl;
}

Log::~Log() {
  if(std::uncaught_exception()) {
    *this << "Logging shut down due to exception (pid " << (int)getpid() << ")\n"; // << flush;
  } else {
    *this << "Logging successfully shut down (pid " << (int)getpid() << ")\n"; // << flush;
  }
}
