package SctApi.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ProbeView extends JFrame {
    Sct_SctApi.SctApi api;

    JComponent information;
    JComponent control;

    short [] results;

    ControlWidgets ctlWidgets;

    public ProbeView(Sct_SctApi.SctApi a) {
        super("Scan");

        api = a;

        JPanel buttons = new JPanel();

        JButton close = new JButton("Close");
        close.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
        buttons.add(close);

        getContentPane().add(buttons, BorderLayout.SOUTH);

	results = api.probeHarness(0, 0, 0, 0);

        updateResultsPanel();
        createControlPanel();
    }

    void updateResultsPanel() {
        if(information != null)
            getContentPane().remove(information);

        information = Box.createVerticalBox();

	for(int i=0; i<results.length; i++) {
	    information.add(new JLabel("" + (char)results[i]));
	}

        getContentPane().add(information, BorderLayout.NORTH);

        information.invalidate();
        getContentPane().validate();
        //information.doLayout();
        //        information.update();
    }

    class ControlWidgets {
        JTextField partition;
        JTextField crate;
        JTextField rod;
        JTextField harness;
    }

    void createControlPanel() {
        control = Box.createVerticalBox();

        ctlWidgets = new ControlWidgets();

        JComponent probeBox = Box.createHorizontalBox();

        probeBox.add(new JLabel("Partition"));
        ctlWidgets.partition = new JTextField("0");
        probeBox.add(ctlWidgets.partition);

        probeBox.add(new JLabel("Crate"));
        ctlWidgets.crate = new JTextField("0");
        probeBox.add(ctlWidgets.crate);

        probeBox.add(new JLabel("ROD"));
        ctlWidgets.rod = new JTextField("0");
        probeBox.add(ctlWidgets.rod);

        probeBox.add(new JLabel("Harness"));
        ctlWidgets.harness = new JTextField("0");
        probeBox.add(ctlWidgets.harness);

        JButton probeButton = new JButton("Probe");
        probeButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    int partition = Integer.parseInt(ctlWidgets.partition.getText());
                    int crate = Integer.parseInt(ctlWidgets.crate.getText());
                    int rod = Integer.parseInt(ctlWidgets.rod.getText());
                    int harness = Integer.parseInt(ctlWidgets.harness.getText());

                    results  = api.probeHarness(partition, crate, rod, harness);

                    updateResultsPanel();
                }
            });
        probeBox.add(probeButton);

        control.add(probeBox);

        getContentPane().add(control, BorderLayout.CENTER);
    }
}
