#ifndef ARCHIVINGWORKERGROUP_H
#define ARCHIVINGWORKERGROUP_H

#include "SctService/WorkerGroup.h"
#include <boost/shared_ptr.hpp>
#include "Sct/Serializable.h"

using boost::shared_ptr;
using Sct::Serializable;
using SctService::WorkerGroup;

namespace SctArchivingService {
    
/**
  This class is the handles the ArchivingService's worker threads.
  They operate on de-serialized objects from IS.  ATM this is most
  efficient as TestData is stored directly in IS.  Should this switch 
  to a file based storage at some point, then it would be better to just
  use names (strings).
  */
class ArchivingWorkerGroup : public WorkerGroup<shared_ptr<Serializable> > {
public:
    virtual void work(shared_ptr<Serializable>) throw();
};
    
}

#endif //ARCHIVINGWORKERGROUP_H
