#include "ServiceFit.h"
#include "archiving/ArchRawScanResult.h"
#include "archiving/ArchFitScanResult.h"

#include "Sct/SctNames.h"
//#include "SCT/ISManager.h"
#include "Sct/IS/IOManagerIS.h"
#include "SctData/TestResult.h"
#include "SctData/FitScanResult.h"
//#include "Sct/shared_ptr_utility.h"

using namespace Sct;
using namespace SctData;
using namespace Sct::IS;
using namespace boost;



namespace SctArchivingServiceFit {

ArchivingServiceFit::ArchivingServiceFit() {}


void ArchivingServiceFit::runFit() {
    cout<<" I am in ArchivingServiceFit::runFit() " <<endl;
    IPCPartition& p = SctNames::getPartition();
    ISInfoReceiver r(p);
    r.subscribe( "FittedData", ".*Fit.*", ISCallbackFit,this);
    r.run();
}


void ArchivingServiceFit::ISCallbackFit(ISCallbackInfo * isc) {
    cout<<" I am in ArchivingServiceFit::ISCallbackFit " <<endl;
    ArchivingServiceFit* a = static_cast<ArchivingServiceFit*>(isc->parameter());
    a->archiveFit(isc);
}




void ArchivingServiceFit::archiveFit(ISCallbackInfo * isc) {
    cout<<" I am in ArchivingServiceFit::archiveFit " <<endl;
    
    if (isc->reason() != ISInfoCreated && isc->reason() != ISInfoUpdated )
        return;

    //Serializable* ob = ISManager::getManager().getFromIS(*isc);
    shared_ptr<Serializable> ob = IOManagerIS::instance().read(*isc);
    if (ob == 0) {
        cerr << "Failed to get object from IS" << endl;
        return;
    }
    //FitScanResult* fit = dynamic_cast<FitScanResult*>(ob);
    shared_ptr<FitScanResult> fit = dynamic_pointer_cast<FitScanResult>(ob);
    if (fit == 0) {
        cerr << "object wasn't as expected" << endl;
	//delete ob;
        return;
    }

    
    cout << "Archiving  FitScanResult: " << endl;
    //Store FitScanObject:
    ArchFitScanResult archfit(*fit);
    archfit.SetUNIXDir();
    archfit.SaveFitScan();
    archfit.FitScanIsPersisted();

    //delete fit;
    cout << "Test Fit complete" << endl;
}

}
