/*
 * runStatus.java
 *
 * Created on 27 June 2003, 16:47
 */

package DisplayGUI;

/**
 *
 * @author  robinson
 */
public class DisplayStatus {
    
    public static final int UNDEFINED = 0;
    public static final int CONFIGURED = 1;
    public static final int MODULE_GROUP_SELECTION = 1;
    public static final int IS_MONITOR = 2;
    public static final int TEST_DATA = 3;
    public static final int SCTDB_DATA = 4;

    public static final String[] statusNames = {"UNCONFIGURED","ModuleGroup Selection","Data Manager","Test Result","SCTDB Result"};

    public int status;
    public int configuredStatus;
    gui guiControl;
    
    /** Creates a new instance of runStatus */
    public DisplayStatus(gui parent) {
        guiControl=parent;
        status = UNDEFINED;
        configuredStatus=UNDEFINED;
    }
    public void setStatus(int status) {
        this.status=status;
    }
    public int getStatus() {
        return status;
    }
    public void setConfigurationMode() {

// by default, everything in module group 0 to start with
          ConfigurationInterface conf = ConfigurationInterface.getInstance();
          conf.getConfiguration(0);
          if(conf.isConfigured()) {
            guiControl.displayPane.refreshDisplay();
            configuredStatus=CONFIGURED;
            setModuleGroupSelectionMode();
            guiControl.menuBar.enableDisplayMenuItems(true);
            }         
          }

    public void setModuleGroupSelectionMode() {
        unsubscribeAll();
        status=MODULE_GROUP_SELECTION;
        boolean displayWriteAccess=true; 
        guiControl.displayPane.setWriteAccess(displayWriteAccess);
        showParameterSelector();
        guiControl.colorScalePane.setColorScale();
        guiControl.tablesDisplayPane.updateTables();
//        System.out.println("DisplayStatus:: setDisplayColors");
        guiControl.displayPane.setDisplayColors();
        guiControl.displayPane.refreshDisplay();

    }
    public void setISMode() {
        unsubscribeAll();
        status = IS_MONITOR;
        showParameterSelector();
        guiControl.colorScalePane.setColorScale();
        guiControl.isInterface.setServerName(0);  // set Event Data to start with
        guiControl.isInterface.subscribe();
        guiControl.tablesDisplayPane.updateTables();
//        System.out.println("DisplayStatus:: setDisplayColors");
//        guiControl.displayPane.setDisplayColors();
//        guiControl.displayPane.refreshDisplay(); // done in subscribe
    }
    public void setTestDataMode(int testDataType) {
        if(status==TEST_DATA) return;
        unsubscribeAll();
        int oldStatus=status;
        status = TEST_DATA;
        showParameterSelector();
        guiControl.displayPane.resetDisplayOption();
        guiControl.colorScalePane.setColorScale();
        guiControl.testDataInterface.subscribe(testDataType);
        guiControl.tablesDisplayPane.updateTables(oldStatus==SCTDB_DATA || oldStatus==TEST_DATA);
//        System.out.println("DisplayStatus:: setDisplayColors");
//        guiControl.displayPane.setDisplayColors();
//        guiControl.displayPane.refreshDisplay(); // done in subscribe
        guiControl.menuBar.resetTestListFilter(); // set test filter to 'All tests'
    }
    public void setSCTDBDataMode(int testDataType) {
        unsubscribeAll();
        int oldStatus=status;
        status = SCTDB_DATA;
        showParameterSelector();
        guiControl.colorScalePane.setColorScale();
        guiControl.sctdbDataInterface.subscribe(testDataType);
        guiControl.tablesDisplayPane.updateTables(oldStatus==SCTDB_DATA || oldStatus==TEST_DATA);
//        System.out.println("DisplayStatus:: setDisplayColors");
//        guiControl.displayPane.setDisplayColors();
//        guiControl.displayPane.refreshDisplay(); // done in subscribe
    }
    public void unsubscribeAll() {
        if(status==IS_MONITOR) guiControl.isInterface.unsubscribe();
        if(status==TEST_DATA) guiControl.testDataInterface.unsubscribe();
        if(status==SCTDB_DATA) guiControl.sctdbDataInterface.unsubscribe();
        }
    private void showParameterSelector() {
        guiControl.selectorPane.initParamList();
        }
}
