package ProdDatabase;
import java.sql.*;
import java.util.*;

public class BarrelUtilities implements SCTDBInfo {


// *****************************************************************************************************************
    public static Vector getHybridVector(String sn1,String sn2,String locn) throws Exception {
// return a Vector containing bmHASIC serial nos, located at locn, not-assembled, with
// corresponding bmHPCs at the same locn also non-assembled

// convert to bmHASIC
      sn1 = sn1.substring(0,7)+"8"+sn1.substring(8);
      sn2 = sn2.substring(0,7)+"8"+sn2.substring(8);
      Vector itemList = new Vector();
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,assembled FROM items WHERE ser_no >="+sn1+" AND ser_no <="+sn2+" AND locn_name = '"+locn+"'");
      sqlStat.append(" ORDER BY ser_no");
//      System.out.println(sqlStat.toString());

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      Hashtable tempHash = new Hashtable();
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         if(aFlag.equals("NO")) tempHash.put(serno,"1");
         else System.out.println("Cannot assemble hybrid "+serno+" - this is already assembled.");
	    }
      statement.close();
      if(recordCount==0) {
           System.out.println("There are "+recordCount+" hybrids located at "+locn+" within the requested range.");
           return itemList;
           }
// now check that the bmHPC are there too
      String firstbit = sn1.substring(0,7);
      String lastbit = sn1.substring(8);
      String sn1_2 = firstbit+"7"+lastbit;
      firstbit = sn2.substring(0,7);
      lastbit = sn2.substring(8);
      String sn2_2 = firstbit+"7"+lastbit;

      sqlStat = new StringBuffer("SELECT ser_no,assembled FROM items WHERE ser_no >="+sn1_2+" AND ser_no <="+sn2_2+" AND locn_name = '"+locn+"'");
      sqlStat.append(" ORDER BY ser_no");
//      System.out.println(sqlStat.toString());
      statement = db.connection.createStatement();
      resultSet = statement.executeQuery(sqlStat.toString());
      recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         if(aFlag.equals("NO")) {
              String bmHASIC = serno.substring(0,7)+"8"+serno.substring(8);
              if(tempHash.containsKey(bmHASIC)) itemList.add(serno.substring(0,7)+"0"+serno.substring(8));
              }
         else System.out.println("Cannot assemble bare hybrid "+serno+" - this is already assembled.");
      }
      statement.close();
      System.out.println("There are "+recordCount+" hybrids located at "+locn+" within the requested range.");
      System.out.println("Of these, "+itemList.size()+" are not yet assembled.");
 
      return itemList;
      }
// *****************************************************************************************************************
    public static Vector getBaseBoardVector(String sn1,String sn2,String locn) throws Exception {
// return a Vector containing bmHASIC serial nos, located at locn, not-assembled, with
// corresponding bmHPCs at the same locn also non-assembled

      Vector itemList = new Vector();
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,assembled FROM items WHERE ser_no >="+sn1+" AND ser_no <="+sn2+" AND locn_name = '"+locn+"'");
      sqlStat.append(" ORDER BY ser_no");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      Hashtable tempHash = new Hashtable();
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         if(aFlag.equals("NO")) tempHash.put(serno,"1");
         else System.out.println("Cannot assemble to sensor-baseboard "+serno+" - this is already assembled.");
	    }
      statement.close();
      if(recordCount==0) {
             System.out.println("There are "+recordCount+" sensor-baseboards located at "+locn+" within the requested range.");
             return itemList;
             }
// now check that the bmBB are there too
      String firstbit = sn1.substring(0,7);
      String lastbit = sn1.substring(8);
      String sn1_2 = firstbit+"8"+lastbit;
      firstbit = sn2.substring(0,7);
      lastbit = sn2.substring(8);
      String sn2_2 = firstbit+"8"+lastbit;

      sqlStat = new StringBuffer("SELECT ser_no,assembled FROM items WHERE ser_no >="+sn1_2+" AND ser_no <="+sn2_2+" AND locn_name = '"+locn+"'");
      sqlStat.append(" ORDER BY ser_no");
//      System.out.println(sqlStat.toString());
      statement = db.connection.createStatement();
      resultSet = statement.executeQuery(sqlStat.toString());
      recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         if(aFlag.equals("NO")) {
              String bmSB = serno.substring(0,7)+"0"+serno.substring(8);
              if(tempHash.containsKey(bmSB)) itemList.add(bmSB);
              }
         else System.out.println("Cannot assemble bare baseboard "+serno+" - this is already assembled.");
      }
      statement.close();
      System.out.println("There are "+recordCount+" sensor-baseboards located at "+locn+" within the requested range.");
      System.out.println("Of these, "+itemList.size()+" are not yet assembled.");
      return itemList;
      }
// *****************************************************************************************************************
    public static Vector getModuleVector(String sn1,String sn2,String locn) throws Exception {
// return a Vector containing module serial nos, located at locn, not-assembled
      Vector itemList = new Vector();
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,assembled FROM items WHERE ser_no >="+sn1+" AND ser_no <="+sn2+" AND locn_name = '"+locn+"'");
      sqlStat.append(" ORDER BY ser_no");
//      System.out.println(sqlStat.toString());
      Hashtable tempHash = new Hashtable();

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         if(aFlag.equals("NO")) tempHash.put(serno,"1");
         else System.out.println("Cannot assemble to module "+serno+" - this is already assembled.");
	    }
      statement.close();
      if(recordCount==0) {
         System.out.println("There are "+recordCount+" modules located at "+locn+" within the requested range.");
         return itemList;
         }
// now check that the bmHASIC are there too, they must be NOT-assembled
      String firstbit = sn1.substring(0,7);
      String lastbit = sn1.substring(8);
      String sn1_2 = firstbit+"8"+lastbit;
      firstbit = sn2.substring(0,7);
      lastbit = sn2.substring(8);
      String sn2_2 = firstbit+"8"+lastbit;

      sqlStat = new StringBuffer("SELECT ser_no,assembled FROM items WHERE ser_no >="+sn1_2+" AND ser_no <="+sn2_2+" AND locn_name = '"+locn+"'");
      sqlStat.append(" ORDER BY ser_no");
//      System.out.println(sqlStat.toString());
      statement = db.connection.createStatement();
      resultSet = statement.executeQuery(sqlStat.toString());
      recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         if(!aFlag.equals("NO")) System.out.println("Cannot assemble ASIC_HYBRID "+serno+" - this is already assembled.");
         else {
            String bmModule = serno.substring(0,7)+"0"+serno.substring(8);
            if(tempHash.containsKey(bmModule)) itemList.addElement(bmModule);
            else System.out.println(bmModule+" is not located at "+locn);
         }
      }
      statement.close();
      System.out.println("There are "+recordCount+" modules located at "+locn+" within the requested range.");
      System.out.println("Of these, "+itemList.size()+" are not yet assembled.");

      return itemList;
      }
// *****************************************************************************************************************
    public static boolean checkSensorList(Vector snList,String locn) throws Exception {

      StringBuffer snBuffer = new StringBuffer();
      int ndets=0;
      for(int i=0;i<snList.size();i++) {
          if(ndets>0) snBuffer.append(",");
          snBuffer.append((String)snList.elementAt(i));
          ndets++;
          }
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,assembled,locn_name FROM items WHERE ser_no IN ("+snBuffer.toString()+")");
      sqlStat.append(" AND ctype='bmSiDetectorOut'");
      sqlStat.append(" ORDER BY ser_no");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());

      int recordCount=0;
      int nready=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         recordCount++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         String thislocn = resultSet.getString(3);
         if(aFlag.equals("NO") && thislocn.equals(locn)) nready++;
         else {
              if(aFlag.equals("YES")) System.out.println("Cannot assemble sensor "+serno+" - this is already assembled.");
              if(!thislocn.equals(locn))  System.out.println("Cannot assemble sensor "+serno+" - this is at "+thislocn+", not "+locn);
	    }
         }
      statement.close();
      if(nready!=4) return false;
      return true;
      }
// *****************************************************************************************************************
    public static boolean checkSensorBaseboard(String sn,String locn) throws Exception {


      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,assembled,locn_name FROM items WHERE ser_no = "+sn);
      sqlStat.append(" AND ctype='bmSB'");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());

      int nready=0;
      int ncounts=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
         ncounts++;
         String serno = resultSet.getString(1);
         String aFlag = resultSet.getString(2);
         String thislocn = resultSet.getString(3);
         if(aFlag.equals("NO") && thislocn.equals(locn)) nready++;
         else {
              if(aFlag.equals("YES")) System.out.println("Cannot assemble sensor-baseboard "+serno+" - this is already assembled.");
              if(!thislocn.equals(locn))  System.out.println("Cannot assemble sensor-baseboard "+serno+" - this is at "+thislocn+", not "+locn);
	    }
         }
      
      statement.close();
      if(ncounts==0) System.out.println("No sensor-baseboard registered with serial no "+sn);
      if(nready!=1) return false;
      return true;
      }

// *****************************************************************************************************************
    public static Hashtable getChipHash(Vector chipList, String thisLocn) throws Exception {
      Hashtable thisHash = new Hashtable();
      StringBuffer mfrSerNos = new StringBuffer();
      for(int i=0;i<chipList.size();i++) {
          if(i>0) mfrSerNos.append(",");
          mfrSerNos.append("'"+(String)chipList.elementAt(i)+"'"); 
          }
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,mfr_ser_no,locn_name FROM items WHERE mfr_ser_no IN ("+mfrSerNos.toString()+") AND ctype='chABCD3T' AND assembled='NO'");
      sqlStat.append(" ORDER BY ser_no");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          recordCount++;
          String sn = resultSet.getString(1);   
          String mfr = resultSet.getString(2);
          String locn = resultSet.getString(3);
          if(!locn.equals(thisLocn)) {
                  System.out.println("Chip "+mfr+" is owned by "+locn+", not "+thisLocn+"!");
                  continue;
                  }
          thisHash.put(mfr,sn);
	    }
//      System.out.println("Retrieved "+recordCount+" records in total.");
      statement.close();
      return thisHash;
      }
// *****************************************************************************************************************
    public static Vector getItemVector(String serialNo) throws Exception {
      Vector itemList = new Vector();
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("mfr,mfr_ser_no,ctype,locn_name,assembled,trashed FROM items WHERE ser_no="+serialNo);
      sqlStat.append(" ORDER BY ser_no");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      int recordCount=0;
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          recordCount++;
          itemList.addElement(resultSet.getString(1));   // mfr name
          itemList.addElement(resultSet.getString(2));   // mfr serial no
          itemList.addElement(resultSet.getString(3));   // type
          itemList.addElement(resultSet.getString(4));   // location name
          itemList.addElement(resultSet.getString(5));   // assembled flag
          itemList.addElement(resultSet.getString(6));   // trashed flag
	    }
//      System.out.println("Retrieved "+recordCount+" records in total.");
      statement.close();
      return itemList;
      }

// ****************************************************************************************************************
    public static Vector getSNfile(String shipment_no) throws Exception {
      Vector itemList = new Vector();
      Vector theLine =  new Vector();
      theLine.addElement("Serial Number");
      theLine.addElement("Mfr Serial No");
      theLine.addElement("Type");
      theLine.addElement("Current Location");
      theLine.addElement("Assembled?");
      itemList.addElement(theLine);

      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,mfr_ser_no,ctype,locn_name,assembled FROM items");
      sqlStat.append(" WHERE ser_no IN (SELECT ship_items.ser_no FROM ship_items WHERE ship_items.ship_no = "+shipment_no+")");
      sqlStat.append(" ORDER BY ser_no");

      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = db.connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
     int recordCount=0;
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          recordCount++;
          theLine = new Vector();
          theLine.addElement(resultSet.getString(1));   // serial no
          theLine.addElement(resultSet.getString(2));   // mfr serial no
          theLine.addElement(resultSet.getString(3));   // type
          theLine.addElement(resultSet.getString(4));   // location name
          theLine.addElement(resultSet.getString(5));   // assembled flag
          itemList.addElement(theLine);
	    }
      System.out.println("Retrieved "+recordCount+" records in total.");
      statement.close();
      return itemList;
      }
//*******************************************************************************8
      public static Vector checkDataSheets(String location, int fileType, Vector fileList) throws Exception {
          
         StringBuffer sqlStat = new StringBuffer("SELECT run_no FROM tests");
         sqlStat.append(" WHERE tests.locn_name='"+location+"' AND tests.test_name='"+dataSheetTestNames[fileType]+"'");

//      SCTDBInterface db = SCTDBInterface.getInstance();
      Statement statement = SCTDBInterface.getInstance().connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());

        for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          String testFileName = resultSet.getString(1);
          if(fileList.removeElement(testFileName)) {
              System.out.println(testFileName+" is already uploaded, skipping...");
              }
          }
      statement.close();
      return fileList;
      }
//-----------------------------------------------------------------------------------------------
   public static Hashtable getDataSheetStatus(String moduleSerialNo, String bmSBserialNo) throws Exception {
// return a has of testdatasheet name vs DB testno
      Hashtable thisHash = new Hashtable();
      if(moduleSerialNo==null) return thisHash;
      
      StringBuffer sqlStat = new StringBuffer("SELECT ");
      sqlStat.append(" tests.test_no,tests.test_name FROM tests");
      sqlStat.append(" WHERE tests.test_name LIKE 'bm%_RData'");
      sqlStat.append(" AND tests.run_no != 'SIGNOFF'");

      String sn1 = moduleSerialNo.substring(0,7)+"%"+moduleSerialNo.substring(8);
      if(bmSBserialNo!=null) {
         String sn2= bmSBserialNo.substring(0,7)+"%"+bmSBserialNo.substring(8);
         sqlStat.append(" AND (tests.ser_no LIKE '"+sn1+"' OR tests.ser_no LIKE '"+sn2+"')");
         }
      else sqlStat.append(" AND tests.ser_no LIKE '"+sn1+"'");
 
      sqlStat.append(" ORDER BY tests.test_date,tests.test_no");
   
      Statement statement = SCTDBInterface.getInstance().connection.createStatement();
      ResultSet resultSet = statement.executeQuery(sqlStat.toString());
      for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          String testno = resultSet.getString(1);
          String testname = resultSet.getString(2);
          thisHash.put(testname,testno);
          }
      statement.close();
      return thisHash;
      }

}